module Datafiniti

  class User
    attr_accessor :token

    def initialize(api_token=ENV['DATAFINITI_API_KEY'])
      self.token = api_token
    end

    include HTTParty

    base_uri "https://#{ENV['DATAFINITI_API_KEY']}:@api.datafiniti.co"
    basic_auth ENV['DATAFINITI_API_KEY'], ''

    def profile(force=false)
      force ? @profile = get_profile : @profile ||= get_profile
    end

    def method_missing(name, *args, &block)
      profile.has_key?(name.to_s) ? profile[name.to_s] : super
      # profile.has_key?(name.to_s) ? profile.send(name.to_sym) : super
    end

    private

    def get_profile
      JSON.parse(self.class.get "/v2/users/#{self.token}")
    end

  end#user

end#datafiniti
