require 'ostruct'
class Hash
  def method_missing(name, *args, &block)
    self[name.to_s]
    # profile.has_key?(name.to_s) ? profile.send(name.to_sym) : super
  end
end
class DataContainer < OpenStruct
  def initialize(hash=nil)
    @table = Hash.new(nil)
    @hash_table = Hash.new(nil)

    if hash
      hash.each do |k,v|
        @table[k.to_sym] = (v.is_a?(Hash) ? self.class.new(v) : v)
        @hash_table[k.to_sym] = v

        new_ostruct_member(k)
      end
    end
  end

  def to_h
    @hash_table
  end

  def status
    return 204
  end

end
